
Robotics Service Bus - Bug #2544
RST Converter map not thread safe
05/10/2016 02:42 PM - M. Pohling

Status: Resolved Start date: 05/10/2016
Priority: Normal Due date:
Assignee: J. Wienke % Done: 100%
Category: Java Estimated time: 0.00 hour
Target version: rsb-0.13
Description

During system start one of my local servers could not be activated because the internal informer crashed because of a concurrent
modification exception. The converter map seems to be not thread safe.

Exception:

Caused by: java.util.ConcurrentModificationException
    at java.util.HashMap$HashIterator.nextNode(HashMap.java:1429)
    at java.util.HashMap$KeyIterator.next(HashMap.java:1453)
    at rsb.converter.DefaultConverterRepository.getConvertersForSerialization(DefaultConverterRepository.java:70)
    at rsb.Informer.<init>(Informer.java:243)
    at rsb.Factory.createInformer(Factory.java:368)
    at rsb.patterns.LocalMethod.<init>(LocalMethod.java:89)
    at rsb.patterns.LocalServer.addMethod(LocalServer.java:82)

Associated revisions
Revision 0dce4827 - 05/11/2016 10:45 AM - J. Wienke

Make DefaultConverterRepository thread-safe

Use a ConcurrentHashMap instead of a normal one. Also reduce the
visibility of the warning message in case a converter is replaced and
document the replacing behavior.

fixes #2545
fixes #2544

Revision cd07c3d6 - 05/11/2016 11:06 AM - J. Wienke

Make DefaultConverterRepository thread-safe

Use a ConcurrentHashMap instead of a normal one. Also reduce the
visibility of the warning message in case a converter is replaced and
document the replacing behavior.

fixes #2545
fixes #2544

(cherry picked from commit 0dce4827849d40bc3fcfbf6b3427b271862e2d67)
History
#1 - 05/10/2016 02:50 PM - M. Pohling

Sorry for missing  tag but reediting afterwards is restricted.

#2 - 05/10/2016 02:51 PM - M. Pohling

M. Pohling wrote:

	
Sorry for missing pre tag but reediting afterwards is restricted.

#3 - 05/10/2016 02:56 PM - J. Moringen
- Description updated

M. Pohling wrote:

	
Sorry for missing pre> tag but reediting afterwards is restricted.

	
Here you go.

#4 - 05/11/2016 10:09 AM - J. Wienke

I think we should make DefaultConverterRepository thread-safe since it is something global.

#5 - 05/11/2016 10:26 AM - J. Wienke
- Status changed from New to In Progress
- Assignee set to J. Wienke
#6 - 05/11/2016 11:08 AM - J. Wienke
- Status changed from In Progress to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:rsb-java|0dce4827849d40bc3fcfbf6b3427b271862e2d67.
